public class UserData {

    private static String player[];
    private static String version[];
    private static String nick[];
    private static String side[];
    private static String color[];
    private static boolean connection[];
    private static boolean ready[];
    private static String ChatBuffer;

    public void Init() {
        player 			= new String[8];
        version 			= new String[8];
        nick 	        	= new String[8];
        side 				= new String[8];
        color 				= new String[8];
        connection 	= new boolean[8];
        ready 				= new boolean[8];

        player[1] = "player1";
        player[2] = "player2";
        player[3] = "player3";
        player[4] = "player4";
        player[5] = "player5";
        player[6] = "player6";
        player[7] = "player7";

        connection[1] = false;
        connection[2] = false;
        connection[3] = false;
        connection[4] = false;
        connection[5] = false;
        connection[6] = false;
        connection[7] = false;

        ready[1] = false;
        ready[2] = false;
        ready[3] = false;
        ready[4] = false;
        ready[5] = false;
        ready[6] = false;
        ready[7] = false;
    }


    public void initUserData(UserData udate, String uplayer) {
        for (int position = 1; position <= 7; position++) {
            if (player[position].equals(uplayer)) {
                version[position] 	= "none";
                nick[position]		= "none";
                side[position]		= "none";
                color[position]		= "none";
                System.out.println ("DEBUG # User Data for " + uplayer + " initialized -> (version : " + version[position] + " | nick : " + nick[position] + " | side : " + side[position] + " | color : " + color[position] + ". ");
            }
        }
    }

    public String setUserInfo(UserData udata, String uplayer, String uversion, String unick, String uside, String ucolor) {
        String recvline = "";

        for (int position = 1; position <= 7; position++) {
            if (player[position].equals(uplayer)) {
                if (!ready[position]) {
                    version[position] 	= uversion;
                    nick[position] 			= unick;
                    side[position] 			= uside;
                    color[position]       = ucolor;
                }
                else
                {
                    recvline = this.printMessagetoClient(player[position], "DATA ALREADY LOCKED.");
                }
            }
        }
        return recvline;
    }

    public void printUserInfo(String uplayer) {
        String tmpstatus = "changing user profile";
        for (int position = 1; position <= 7; position++) {
            if (player[position].equals(uplayer)) {
                if ( (version[position] != "none") && (nick[position] != "none") && (side[position] != "none") && (color[position] != "none") ) {
                    if (ready[position]) { tmpstatus = "awaiting game start"; }
                    System.out.println (player[position] + " ::: " + version[position] + " ::: " + nick[position] + " ::: " + side[position] + " ::: " + color[position] + " ::: " + tmpstatus);
                }
            }
        }
    }

    public String printServerInfo(String uplayer, Values valuu) {
        String recvline;

        if (this.askforGameStart(valuu)) {
            System.out.println ("GAME CAN START NOW!");
            recvline = this.printMessagetoClient(uplayer, "GAME WILL BE STARTED BY SERVER NOW");
        }
        else {
            recvline = "AWATING OTHER PLAYERS TO JOIN";
        }
        return recvline;
    }

    public void cleanupUser(String uplayer, Values val) {
        for (int position = 1; position <= 7; position++) {
            if (player[position].equals(uplayer)) {
                version[position]       = "";
                nick[position]		= "";
                side[position]		= "";
                color[position]		= "";
                ready[position]			= false;
                connection[position]    	= false;
                val.gamestate(0);
                System.out.println("cleaned up queue for player " + uplayer + ". needs " + (val.getmaxplayers() - val.getnumplayers()) + " more players to start the game.");
            }
        }
    }

    public String printMessagetoClient(String uplayer, String message) {
        String recvline = null;
        recvline = "MESSAGE FROM MASTERSERVER to " + uplayer + " ::: " + message;
        return recvline;
    }

    public String printUserInfoToClient(String uplayer) {
        String recvline = null;
        String tmpstatus = "changing user profile";
        for (int position = 1; position <= 7; position++) {
            if (player[position].equals(uplayer)) {
                if ( (version[position] != "none") && (nick[position] != "none") && (side[position] != "none") && (color[position] != "none") ) {
                    if (ready[position]) { tmpstatus = "awaiting game start"; }
                    recvline = player[position] + " ::: " + version[position] + " ::: " + nick[position] + " ::: " + side[position] + " ::: " + color[position] + " ::: " + tmpstatus;
                }
            }
        }
        return recvline;
    }

    public boolean checkNick(String cid, String tempnick) {
        boolean retvalue = true;
        for (int position = 1; position <= 7; position++) {
            try {
                if ( (nick[position] != "none") || (nick[position] != null) )
                {
                    System.out.println ("DEBUG ### " + position + " -- " + nick[position]);
                    if ( (nick[position].equals(tempnick)) )
                    {
                        retvalue = false;
                    }
                }
            } catch (NullPointerException e) {}
        }
        return retvalue;
    }


    public boolean checkColor(String cid, String tempcolor) {
        boolean retvalue = true;
        for (int position = 1; position <= 7; position++) {
            if (color[position] != "none")
            {
                if ( (color[position].equals(tempcolor)) )
                {
                    retvalue = false;
                }
            }
        }
        return retvalue;
    }

    public void putintoChatBuffer(String chatline) {
        ChatBuffer = chatline;
    }

    public void readfromChatBuffer() {
        if (ChatBuffer != null) { System.out.println(ChatBuffer); }
    }

    public synchronized String getPlayerID() {
        String tmpid;
        int position = 1;

        while ( (position <= 7) && (connection[position] == true) ) {
            position++;
        }
        tmpid = "player" + position;
        connection[position] = true;
        return tmpid;
    }

    public boolean checkUser(String user, Values val) {
        boolean tmp = false;
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(user)) {
                System.out.println ("debug ### " + nick[position]);
                System.out.println ("debug ### " + color[position]);
                System.out.println ("debug ### " + side[position]);
                System.out.println ("debug ### " + version[position]);
                if ( 	(nick[position].compareTo("none") != 0) ||
                        (version[position].compareTo("none") != 0) ||
                        (color[position].compareTo("none") != 0) ||
                        (side[position].compareTo("none") != 0) )
                { tmp = true;	}
                else
                { tmp = false; }
            }
        }
        System.out.println ("debug ### returning " + tmp);
        return tmp;
    }


    public boolean checkAllUsers(Values val) {
        boolean tmp = true;
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (!this.checkUser(player[position], val)) { tmp = false; }
        }
        return tmp;
    }


    public boolean askforGameStart(Values val) {
        boolean retval = false;
        if ( (val.getmaxplayers() >= val.getplayernumber() ) && (this.checkAllUsers(val)) )
        {	retval = true; }
        return retval;
    }

    public String setClientAsReady(String user, Values val) {
        String rvline = "";
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(user)) {
                if (this.checkUser(user, val)) {
                    ready[position] = true;
                    System.out.println (player[position] + " announces to be ready to play");
                }
                else {
                    System.out.println (player[position] + "'s settings are refused by server");
                    ready[position] = false;
                }
            }
        }
        if ( val.getplayernumber() < val.getmaxplayers() ) {
            System.out.println ("waiting for " + (val.getmaxplayers() - val.getplayernumber()) + " more players");
        }
        else {
            val.gamestate(1);
            System.out.println ("All users are ready - so we can start the game.");
        }
        rvline = user + " is now marked as ready.";
        return rvline;
    }

    public String printOptions(Values val) {
        String userstring;
        userstring = "Game Options # Map : " + val.getmap() + ", MaxPlayers : " + val.getmaxplayers() + ", Money : " + val.getmoney() + ", Techlevel : " + val.gettechlevel() + ", Crates : " + val.getcrates() + ", CTF : " + val.getctf() + ", Players connected : " + val.getplayernumber();
        return userstring;
    }


}
