#ifndef __CURSORPOOL_H_
#define __CURSORPOOL_H_

#include "SDL.h"
#include <vector>
#include <map>
#include <string>
#include "inifile.h"

typedef struct {
    Uint16 anstart,anend;
}
cursorinfo;

class CursorPool {
private:
    vector<cursorinfo*> cursorpool;
    map<string, Uint16> name2index;
    INIFile* cursorini;
public:
    CursorPool(char* ininame);
    ~CursorPool();
    cursorinfo* getCursorByName(char* name);
};

#endif /* __CURSORPOOL_H_ */
